<!DOCTYPE html><html><head>
    <meta charset="utf-8"/>
    <meta name="author" content="Apple Inc."/>
    <meta name="viewport" content="width=device-width initial-scale=1"/>
    
    <a class="dashingAutolink" name="autolink-1"></a><a class="dashAnchor" name="//apple_ref/cpp/Guide/A%20Swift%20Tour%20%E2%80%94%20The%20Swift%20Programming%20Language%20%28Swift%204.2%29"></a><title>A Swift Tour &mdash; The Swift Programming Language (Swift 4.2)</title>
    
    <link rel="license" href="https://docs.swift.org/LICENSE.txt"/>
    <link rel="stylesheet" media="all" href="../_static/stylesheets/application.css"/>
    <link rel="stylesheet" media="all" href="../_static/stylesheets/tspl.css"/>
    <link rel="shortcut icon" sizes="16x16 24x24 32x32 48x48 64x64" type="image/vnd.microsoft.icon" href="../../favicon.ico"/>
    <link rel="apple-touch-icon" href="https://docs.swift.org/apple-touch-icon.png"/>
    <link rel="apple-touch-icon" sizes="57x57" href="https://docs.swift.org/apple-touch-icon-57x57.png"/>
    <link rel="apple-touch-icon" sizes="72x72" href="https://docs.swift.org/apple-touch-icon-72x72.png"/>
    <link rel="apple-touch-icon" sizes="76x76" href="https://docs.swift.org/apple-touch-icon-76x76.png"/>
    <link rel="apple-touch-icon" sizes="114x114" href="https://docs.swift.org/apple-touch-icon-114x114.png"/>
    <link rel="apple-touch-icon" sizes="120x120" href="https://docs.swift.org/apple-touch-icon-120x120.png"/>
    <link rel="apple-touch-icon" sizes="144x144" href="https://docs.swift.org/apple-touch-icon-144x144.png"/>
    <link rel="apple-touch-icon" sizes="152x152" href="https://docs.swift.org/apple-touch-icon-152x152.png"/>
    <link rel="apple-touch-icon" sizes="180x180" href="https://docs.swift.org/apple-touch-icon-180x180.png"/>
    <link rel="mask-icon" href="https://docs.swift.org/assets/images/icon-swift.svg" color="#F05339"/> 
  </head>
  <body>


<nav role="navigation">
    <header role="banner">
      <h1 id="logo">
        <a href="https://swift.org/" title="Swift.org" role="img" aria-label="Swift.org">
          Swift.org
        </a>
      </h1>
    </header>

    <div id="menu-toggle" class="menu-toggle open"></div>

    <h2>The Swift Programming Language<div>Swift 4.2</div></h2>

    <ul>
    <ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../index.html">Welcome to Swift</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../index.html">About Swift</a></li>
<li class="toctree-l2"><a class="reference internal" href="Compatibility.html">Version Compatibility</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="GuidedTour.html#">A Swift Tour</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../LanguageGuide/TheBasics.html">Language Guide</a></li>
<li class="toctree-l1"><a class="reference internal" href="../ReferenceManual/AboutTheLanguageReference.html">Language Reference</a></li>
<li class="toctree-l1"><a class="reference internal" href="../RevisionHistory/RevisionHistory.html">Revision History</a></li>
</ul>

    <li class="toctree-l1 return"><a class="reference internal" href="https://swift.org/">&larr; Return to Swift.org</a></li>
    </ul>
</nav>




<main role="main">
    <article class="page">
        <menu id="bashful" type="toolbar">
          <div class="inner">
            <menuitem id="jump_to" class="menu-bar-item closed">
            <span id="jump_to_toggle">On This Page</span>
            <div class="chevron">
                <div class="chevy chevron-left"></div>
                <div class="chevy chevron-right"></div>
            </div>
            <menu type="list" class="details">
                <ul>
<li><a class="reference internal" href="GuidedTour.html#">A Swift Tour</a><ul>
<li><a class="reference internal" href="GuidedTour.html#ID461">Simple Values</a></li>
<li><a class="reference internal" href="GuidedTour.html#ID462">Control Flow</a></li>
<li><a class="reference internal" href="GuidedTour.html#ID463">Functions and Closures</a></li>
<li><a class="reference internal" href="GuidedTour.html#ID464">Objects and Classes</a></li>
<li><a class="reference internal" href="GuidedTour.html#ID465">Enumerations and Structures</a></li>
<li><a class="reference internal" href="GuidedTour.html#ID466">Protocols and Extensions</a></li>
<li><a class="reference internal" href="GuidedTour.html#error-handling">Error Handling</a></li>
<li><a class="reference internal" href="GuidedTour.html#generics">Generics</a></li>
</ul>
</li>
</ul>

            </menu>
            </menuitem>
          </div>
        </menu>

        
  <div class="section" id="a-swift-tour">
<h1>A Swift Tour<a class="headerlink" href="GuidedTour.html#a-swift-tour" title="Permalink to this headline"></a></h1>
<p>Tradition suggests that the first program in a new language should print the words &ldquo;Hello, world!&rdquo; on the screen. In Swift, this can be done in a single line:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">print</span>(<span class="s">&#34;Hello, world!&#34;</span>)
</li></ol></pre></div></div>
<p>If you have written code in C or Objective-C, this syntax looks familiar to you&mdash;in Swift, this line of code is a complete program. You don&rsquo;t need to import a separate library for functionality like input/output or string handling. Code written at global scope is used as the entry point for the program, so you don&rsquo;t need a <code class="docutils literal"><span class="pre">main()</span></code> function. You also don&rsquo;t need to write semicolons at the end of every statement.</p>
<p>This tour gives you enough information to start writing code in Swift by showing you how to accomplish a variety of programming tasks. Don&rsquo;t worry if you don&rsquo;t understand something&mdash;everything introduced in this tour is explained in detail in the rest of this book.</p>
<div class="playground_link admonition">
<p class="first admonition-title">Note</p>
<p>For the best experience, open this chapter as a playground in Xcode.
Playgrounds allow you to edit the code listings and see the result immediately.
</p>
<p class="last"><a class="reference external" href="GuidedTour.playground.zip">Download Playground</a></p>
</div>
<div class="section" id="ID461">
<a class="dashingAutolink" name="autolink-2"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Simple%20Values"></a><h2>Simple Values<a class="headerlink" href="GuidedTour.html#ID461" title="Permalink to this headline"></a></h2>
<p>Use <code class="docutils literal"><span class="pre">let</span></code> to make a constant and <code class="docutils literal"><span class="pre">var</span></code> to make a variable. The value of a constant doesn&rsquo;t need to be known at compile time, but you must assign it a value exactly once. This means you can use constants to name a value that you determine once but use in many places.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">myVariable</span> = <span class="m">42</span>
</li><li><span class="nv">myVariable</span> = <span class="m">50</span>
</li><li><span class="k">let</span> <span class="nv">myConstant</span> = <span class="m">42</span>
</li></ol></pre></div></div>
<p>A constant or variable must have the same type as the value you want to assign to it. However, you don&rsquo;t always have to write the type explicitly. Providing a value when you create a constant or variable lets the compiler infer its type. In the example above, the compiler infers that <code class="docutils literal"><span class="pre">myVariable</span></code> is an integer because its initial value is an integer.</p>
<p>If the initial value doesn&rsquo;t provide enough information (or if there is no initial value), specify the type by writing it after the variable, separated by a colon.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">implicitInteger</span> = <span class="m">70</span>
</li><li><span class="k">let</span> <span class="nv">implicitDouble</span> = <span class="m">70.0</span>
</li><li><span class="k">let</span> <span class="nv">explicitDouble</span>: <span class="nc">Double</span> = <span class="m">70</span>
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Create a constant with an explicit type of <code class="docutils literal"><span class="pre">Float</span></code> and a value of <code class="docutils literal"><span class="pre">4</span></code>.</p>
</div>
<p>Values are never implicitly converted to another type. If you need to convert a value to a different type, explicitly make an instance of the desired type.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">label</span> = <span class="s">&#34;The width is &#34;</span>
</li><li><span class="k">let</span> <span class="nv">width</span> = <span class="m">94</span>
</li><li><span class="k">let</span> <span class="nv">widthLabel</span> = <span class="nv">label</span> + <span class="nv">String</span>(<span class="nv">width</span>)
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Try removing the conversion to <code class="docutils literal"><span class="pre">String</span></code> from the last line. What error do you get?</p>
</div>
<p>There&rsquo;s an even simpler way to include values in strings: Write the value in parentheses, and write a backslash (<code class="docutils literal"><span class="pre">\</span></code>) before the parentheses. For example:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">apples</span> = <span class="m">3</span>
</li><li><span class="k">let</span> <span class="nv">oranges</span> = <span class="m">5</span>
</li><li><span class="k">let</span> <span class="nv">appleSummary</span> = <span class="s">&#34;I have </span>\<span class="p">(</span><span class="nv">apples</span><span class="p">)</span><span class="s"> apples.&#34;</span>
</li><li><span class="k">let</span> <span class="nv">fruitSummary</span> = <span class="s">&#34;I have </span>\<span class="p">(</span><span class="nv">apples</span> + <span class="nv">oranges</span><span class="p">)</span><span class="s"> pieces of fruit.&#34;</span>
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Use <code class="docutils literal"><span class="pre">\()</span></code> to include a floating-point calculation in a string and to include someone&rsquo;s name in a greeting.</p>
</div>
<p>Use three double quotation marks (<code class="docutils literal"><span class="pre">&#34;&#34;&#34;</span></code>) for strings that take up multiple lines. Indentation at the start of each quoted line is removed, as long as it matches the indentation of the closing quotation marks. For example:</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">quotation</span> = <span class="s">&#34;&#34;&#34;</span>
</li><li><span class="s">I said &#34;I have </span>\<span class="p">(</span><span class="nv">apples</span><span class="p">)</span><span class="s"> apples.&#34;</span>
</li><li><span class="s">And then I said &#34;I have </span>\<span class="p">(</span><span class="nv">apples</span> + <span class="nv">oranges</span><span class="p">)</span><span class="s"> pieces of fruit.&#34;</span>
</li><li><span class="s">&#34;&#34;&#34;</span>
</li></ol></pre></div></div>
<p>Create arrays and dictionaries using brackets (<code class="docutils literal"><span class="pre">[]</span></code>), and access their elements by writing the index or key in brackets. A comma is allowed after the last element.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">shoppingList</span> = [<span class="s">&#34;catfish&#34;</span>, <span class="s">&#34;water&#34;</span>, <span class="s">&#34;tulips&#34;</span>, <span class="s">&#34;blue paint&#34;</span>]
</li><li><span class="nv">shoppingList</span>[<span class="m">1</span>] = <span class="s">&#34;bottle of water&#34;</span>
</li><li>
</li><li><span class="k">var</span> <span class="nv">occupations</span> = [
</li><li>    <span class="s">&#34;Malcolm&#34;</span>: <span class="s">&#34;Captain&#34;</span>,
</li><li>    <span class="s">&#34;Kaylee&#34;</span>: <span class="s">&#34;Mechanic&#34;</span>,
</li><li>]
</li><li><span class="nv">occupations</span>[<span class="s">&#34;Jayne&#34;</span>] = <span class="s">&#34;Public Relations&#34;</span>
</li></ol></pre></div></div>
<p>To create an empty array or dictionary, use the initializer syntax.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">emptyArray</span> = [<span class="nv">String</span>]()
</li><li><span class="k">let</span> <span class="nv">emptyDictionary</span> = [<span class="nv">String</span>: <span class="nv">Float</span>]()
</li></ol></pre></div></div>
<p>If type information can be inferred, you can write an empty array as <code class="docutils literal"><span class="pre">[]</span></code> and an empty dictionary as <code class="docutils literal"><span class="pre">[:]</span></code>&mdash;for example, when you set a new value for a variable or pass an argument to a function.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">shoppingList</span> = []
</li><li><span class="nv">occupations</span> = [:]
</li></ol></pre></div></div>
</div>
<div class="section" id="ID462">
<a class="dashingAutolink" name="autolink-3"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Control%20Flow"></a><h2>Control Flow<a class="headerlink" href="GuidedTour.html#ID462" title="Permalink to this headline"></a></h2>
<p>Use <code class="docutils literal"><span class="pre">if</span></code> and <code class="docutils literal"><span class="pre">switch</span></code> to make conditionals, and use <code class="docutils literal"><span class="pre">for</span></code>-<code class="docutils literal"><span class="pre">in</span></code>, <code class="docutils literal"><span class="pre">while</span></code>, and <code class="docutils literal"><span class="pre">repeat</span></code>-<code class="docutils literal"><span class="pre">while</span></code> to make loops. Parentheses around the condition or loop variable are optional. Braces around the body are required.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">individualScores</span> = [<span class="m">75</span>, <span class="m">43</span>, <span class="m">103</span>, <span class="m">87</span>, <span class="m">12</span>]
</li><li><span class="k">var</span> <span class="nv">teamScore</span> = <span class="m">0</span>
</li><li><span class="k">for</span> <span class="nv">score</span> <span class="k">in</span> <span class="nv">individualScores</span> {
</li><li>    <span class="k">if</span> <span class="nv">score</span> &gt; <span class="m">50</span> {
</li><li>        <span class="nv">teamScore</span> += <span class="m">3</span>
</li><li>    } <span class="k">else</span> {
</li><li>        <span class="nv">teamScore</span> += <span class="m">1</span>
</li><li>    }
</li><li>}
</li><li><span class="nv">print</span>(<span class="nv">teamScore</span>)
</li></ol></pre></div></div>
<p>In an <code class="docutils literal"><span class="pre">if</span></code> statement, the conditional must be a Boolean expression&mdash;this means that code such as <code class="docutils literal"><span class="pre">if</span> <span class="pre">score</span> <span class="pre">{</span> <span class="pre">...</span> <span class="pre">}</span></code> is an error, not an implicit comparison to zero.</p>
<p>You can use <code class="docutils literal"><span class="pre">if</span></code> and <code class="docutils literal"><span class="pre">let</span></code> together to work with values that might be missing. These values are represented as optionals. An optional value either contains a value or contains <code class="docutils literal"><span class="pre">nil</span></code> to indicate that a value is missing. Write a question mark (<code class="docutils literal"><span class="pre">?</span></code>) after the type of a value to mark the value as optional.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">optionalString</span>: <span class="nc">String</span>? = <span class="s">&#34;Hello&#34;</span>
</li><li><span class="nv">print</span>(<span class="nv">optionalString</span> == <span class="k">nil</span>)
</li><li>
</li><li><span class="k">var</span> <span class="nv">optionalName</span>: <span class="nc">String</span>? = <span class="s">&#34;John Appleseed&#34;</span>
</li><li><span class="k">var</span> <span class="nv">greeting</span> = <span class="s">&#34;Hello!&#34;</span>
</li><li><span class="k">if</span> <span class="k">let</span> <span class="nv">name</span> = <span class="nv">optionalName</span> {
</li><li>    <span class="nv">greeting</span> = <span class="s">&#34;Hello, </span>\<span class="p">(</span><span class="nv">name</span><span class="p">)</span><span class="s">&#34;</span>
</li><li>}
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Change <code class="docutils literal"><span class="pre">optionalName</span></code> to <code class="docutils literal"><span class="pre">nil</span></code>. What greeting do you get? Add an <code class="docutils literal"><span class="pre">else</span></code> clause that sets a different greeting if <code class="docutils literal"><span class="pre">optionalName</span></code> is <code class="docutils literal"><span class="pre">nil</span></code>.</p>
</div>
<p>If the optional value is <code class="docutils literal"><span class="pre">nil</span></code>, the conditional is <code class="docutils literal"><span class="pre">false</span></code> and the code in braces is skipped. Otherwise, the optional value is unwrapped and assigned to the constant after <code class="docutils literal"><span class="pre">let</span></code>, which makes the unwrapped value available inside the block of code.</p>
<p>Another way to handle optional values is to provide a default value using the <code class="docutils literal"><span class="pre">??</span></code> operator. If the optional value is missing, the default value is used instead.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">nickName</span>: <span class="nc">String</span>? = <span class="k">nil</span>
</li><li><span class="k">let</span> <span class="nv">fullName</span>: <span class="nc">String</span> = <span class="s">&#34;John Appleseed&#34;</span>
</li><li><span class="k">let</span> <span class="nv">informalGreeting</span> = <span class="s">&#34;Hi </span>\<span class="p">(</span><span class="nv">nickName</span> ?? <span class="nv">fullName</span><span class="p">)</span><span class="s">&#34;</span>
</li></ol></pre></div></div>
<p>Switches support any kind of data and a wide variety of comparison operations&mdash;they aren&rsquo;t limited to integers and tests for equality.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">vegetable</span> = <span class="s">&#34;red pepper&#34;</span>
</li><li><span class="k">switch</span> <span class="nv">vegetable</span> {
</li><li><span class="k">case</span> <span class="s">&#34;celery&#34;</span>:
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Add some raisins and make ants on a log.&#34;</span>)
</li><li><span class="k">case</span> <span class="s">&#34;cucumber&#34;</span>, <span class="s">&#34;watercress&#34;</span>:
</li><li>    <span class="nv">print</span>(<span class="s">&#34;That would make a good tea sandwich.&#34;</span>)
</li><li><span class="k">case</span> <span class="k">let</span> <span class="nv">x</span> <span class="k">where</span> <span class="nv">x</span>.<span class="nv">hasSuffix</span>(<span class="s">&#34;pepper&#34;</span>):
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Is it a spicy </span>\<span class="p">(</span><span class="nv">x</span><span class="p">)</span><span class="s">?&#34;</span>)
</li><li><span class="k">default</span>:
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Everything tastes good in soup.&#34;</span>)
</li><li>}
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Try removing the default case. What error do you get?</p>
</div>
<p>Notice how <code class="docutils literal"><span class="pre">let</span></code> can be used in a pattern to assign the value that matched the pattern to a constant.</p>
<p>After executing the code inside the switch case that matched, the program exits from the switch statement. Execution doesn&rsquo;t continue to the next case, so there is no need to explicitly break out of the switch at the end of each case&rsquo;s code.</p>
<p>You use <code class="docutils literal"><span class="pre">for</span></code>-<code class="docutils literal"><span class="pre">in</span></code> to iterate over items in a dictionary by providing a pair of names to use for each key-value pair. Dictionaries are an unordered collection, so their keys and values are iterated over in an arbitrary order.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">interestingNumbers</span> = [
</li><li>    <span class="s">&#34;Prime&#34;</span>: [<span class="m">2</span>, <span class="m">3</span>, <span class="m">5</span>, <span class="m">7</span>, <span class="m">11</span>, <span class="m">13</span>],
</li><li>    <span class="s">&#34;Fibonacci&#34;</span>: [<span class="m">1</span>, <span class="m">1</span>, <span class="m">2</span>, <span class="m">3</span>, <span class="m">5</span>, <span class="m">8</span>],
</li><li>    <span class="s">&#34;Square&#34;</span>: [<span class="m">1</span>, <span class="m">4</span>, <span class="m">9</span>, <span class="m">16</span>, <span class="m">25</span>],
</li><li>]
</li><li><span class="k">var</span> <span class="nv">largest</span> = <span class="m">0</span>
</li><li><span class="k">for</span> (<span class="nv">kind</span>, <span class="nv">numbers</span>) <span class="k">in</span> <span class="nv">interestingNumbers</span> {
</li><li>    <span class="k">for</span> <span class="nv">number</span> <span class="k">in</span> <span class="nv">numbers</span> {
</li><li>        <span class="k">if</span> <span class="nv">number</span> &gt; <span class="nv">largest</span> {
</li><li>            <span class="nv">largest</span> = <span class="nv">number</span>
</li><li>        }
</li><li>    }
</li><li>}
</li><li><span class="nv">print</span>(<span class="nv">largest</span>)
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Add another variable to keep track of which kind of number was the largest, as well as what that largest number was.</p>
</div>
<p>Use <code class="docutils literal"><span class="pre">while</span></code> to repeat a block of code until a condition changes. The condition of a loop can be at the end instead, ensuring that the loop is run at least once.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">n</span> = <span class="m">2</span>
</li><li><span class="k">while</span> <span class="nv">n</span> &lt; <span class="m">100</span> {
</li><li>    <span class="nv">n</span> *= <span class="m">2</span>
</li><li>}
</li><li><span class="nv">print</span>(<span class="nv">n</span>)
</li><li>
</li><li><span class="k">var</span> <span class="nv">m</span> = <span class="m">2</span>
</li><li><span class="k">repeat</span> {
</li><li>    <span class="nv">m</span> *= <span class="m">2</span>
</li><li>} <span class="k">while</span> <span class="nv">m</span> &lt; <span class="m">100</span>
</li><li><span class="nv">print</span>(<span class="nv">m</span>)
</li></ol></pre></div></div>
<p>You can keep an index in a loop by using <code class="docutils literal"><span class="pre">..&lt;</span></code> to make a range of indexes.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">total</span> = <span class="m">0</span>
</li><li><span class="k">for</span> <span class="nv">i</span> <span class="k">in</span> <span class="m">0</span>..&lt;<span class="m">4</span> {
</li><li>    <span class="nv">total</span> += <span class="nv">i</span>
</li><li>}
</li><li><span class="nv">print</span>(<span class="nv">total</span>)
</li></ol></pre></div></div>
<p>Use <code class="docutils literal"><span class="pre">..&lt;</span></code> to make a range that omits its upper value, and use <code class="docutils literal"><span class="pre">...</span></code> to make a range that includes both values.</p>
</div>
<div class="section" id="ID463">
<a class="dashingAutolink" name="autolink-4"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Functions%20and%20Closures"></a><h2>Functions and Closures<a class="headerlink" href="GuidedTour.html#ID463" title="Permalink to this headline"></a></h2>
<p>Use <code class="docutils literal"><span class="pre">func</span></code> to declare a function. Call a function by following its name with a list of arguments in parentheses. Use <code class="docutils literal"><span class="pre">-&gt;</span></code> to separate the parameter names and types from the function&rsquo;s return type.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">greet</span>(<span class="nv">person</span>: <span class="nc">String</span>, <span class="nv">day</span>: <span class="nc">String</span>) -&gt; <span class="nc">String</span> {
</li><li>    <span class="k">return</span> <span class="s">&#34;Hello </span>\<span class="p">(</span><span class="nv">person</span><span class="p">)</span><span class="s">, today is </span>\<span class="p">(</span><span class="nv">day</span><span class="p">)</span><span class="s">.&#34;</span>
</li><li>}
</li><li><span class="nv">greet</span>(<span class="nv">person</span>: <span class="s">&#34;Bob&#34;</span>, <span class="nv">day</span>: <span class="s">&#34;Tuesday&#34;</span>)
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Remove the <code class="docutils literal"><span class="pre">day</span></code> parameter. Add a parameter to include today&rsquo;s lunch special in the greeting.</p>
</div>
<p>By default, functions use their parameter names as labels for their arguments. Write a custom argument label before the parameter name, or write <code class="docutils literal"><span class="pre">_</span></code> to use no argument label.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">greet</span>(<span class="k">_</span> <span class="nv">person</span>: <span class="nc">String</span>, <span class="nv">on</span> <span class="nv">day</span>: <span class="nc">String</span>) -&gt; <span class="nc">String</span> {
</li><li>    <span class="k">return</span> <span class="s">&#34;Hello </span>\<span class="p">(</span><span class="nv">person</span><span class="p">)</span><span class="s">, today is </span>\<span class="p">(</span><span class="nv">day</span><span class="p">)</span><span class="s">.&#34;</span>
</li><li>}
</li><li><span class="nv">greet</span>(<span class="s">&#34;John&#34;</span>, <span class="nv">on</span>: <span class="s">&#34;Wednesday&#34;</span>)
</li></ol></pre></div></div>
<p>Use a tuple to make a compound value&mdash;for example, to return multiple values from a function. The elements of a tuple can be referred to either by name or by number.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">calculateStatistics</span>(<span class="nv">scores</span>: [<span class="nc">Int</span>]) -&gt; (<span class="nv">min</span>: <span class="nc">Int</span>, <span class="nv">max</span>: <span class="nc">Int</span>, <span class="nv">sum</span>: <span class="nc">Int</span>) {
</li><li>    <span class="k">var</span> <span class="nv">min</span> = <span class="nv">scores</span>[<span class="m">0</span>]
</li><li>    <span class="k">var</span> <span class="nv">max</span> = <span class="nv">scores</span>[<span class="m">0</span>]
</li><li>    <span class="k">var</span> <span class="nv">sum</span> = <span class="m">0</span>
</li><li>
</li><li>    <span class="k">for</span> <span class="nv">score</span> <span class="k">in</span> <span class="nv">scores</span> {
</li><li>        <span class="k">if</span> <span class="nv">score</span> &gt; <span class="nv">max</span> {
</li><li>            <span class="nv">max</span> = <span class="nv">score</span>
</li><li>        } <span class="k">else</span> <span class="k">if</span> <span class="nv">score</span> &lt; <span class="nv">min</span> {
</li><li>            <span class="nv">min</span> = <span class="nv">score</span>
</li><li>        }
</li><li>        <span class="nv">sum</span> += <span class="nv">score</span>
</li><li>    }
</li><li>
</li><li>    <span class="k">return</span> (<span class="nv">min</span>, <span class="nv">max</span>, <span class="nv">sum</span>)
</li><li>}
</li><li><span class="k">let</span> <span class="nv">statistics</span> = <span class="nv">calculateStatistics</span>(<span class="nv">scores</span>: [<span class="m">5</span>, <span class="m">3</span>, <span class="m">100</span>, <span class="m">3</span>, <span class="m">9</span>])
</li><li><span class="nv">print</span>(<span class="nv">statistics</span>.<span class="nv">sum</span>)
</li><li><span class="nv">print</span>(<span class="nv">statistics</span>.<span class="m">2</span>)
</li></ol></pre></div></div>
<p>Functions can be nested. Nested functions have access to variables that were declared in the outer function. You can use nested functions to organize the code in a function that is long or complex.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">returnFifteen</span>() -&gt; <span class="nc">Int</span> {
</li><li>    <span class="k">var</span> <span class="nv">y</span> = <span class="m">10</span>
</li><li>    <span class="k">func</span> <span class="nv">add</span>() {
</li><li>        <span class="nv">y</span> += <span class="m">5</span>
</li><li>    }
</li><li>    <span class="nv">add</span>()
</li><li>    <span class="k">return</span> <span class="nv">y</span>
</li><li>}
</li><li><span class="nv">returnFifteen</span>()
</li></ol></pre></div></div>
<p>Functions are a first-class type. This means that a function can return another function as its value.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">makeIncrementer</span>() -&gt; ((<span class="nc">Int</span>) -&gt; <span class="nc">Int</span>) {
</li><li>    <span class="k">func</span> <span class="nv">addOne</span>(<span class="nv">number</span>: <span class="nc">Int</span>) -&gt; <span class="nc">Int</span> {
</li><li>        <span class="k">return</span> <span class="m">1</span> + <span class="nv">number</span>
</li><li>    }
</li><li>    <span class="k">return</span> <span class="nv">addOne</span>
</li><li>}
</li><li><span class="k">var</span> <span class="nv">increment</span> = <span class="nv">makeIncrementer</span>()
</li><li><span class="nv">increment</span>(<span class="m">7</span>)
</li></ol></pre></div></div>
<p>A function can take another function as one of its arguments.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">hasAnyMatches</span>(<span class="nv">list</span>: [<span class="nc">Int</span>], <span class="nv">condition</span>: (<span class="nc">Int</span>) -&gt; <span class="nc">Bool</span>) -&gt; <span class="nc">Bool</span> {
</li><li>    <span class="k">for</span> <span class="nv">item</span> <span class="k">in</span> <span class="nv">list</span> {
</li><li>        <span class="k">if</span> <span class="nv">condition</span>(<span class="nv">item</span>) {
</li><li>            <span class="k">return</span> <span class="k">true</span>
</li><li>        }
</li><li>    }
</li><li>    <span class="k">return</span> <span class="k">false</span>
</li><li>}
</li><li><span class="k">func</span> <span class="nv">lessThanTen</span>(<span class="nv">number</span>: <span class="nc">Int</span>) -&gt; <span class="nc">Bool</span> {
</li><li>    <span class="k">return</span> <span class="nv">number</span> &lt; <span class="m">10</span>
</li><li>}
</li><li><span class="k">var</span> <span class="nv">numbers</span> = [<span class="m">20</span>, <span class="m">19</span>, <span class="m">7</span>, <span class="m">12</span>]
</li><li><span class="nv">hasAnyMatches</span>(<span class="nv">list</span>: <span class="nv">numbers</span>, <span class="nv">condition</span>: <span class="nv">lessThanTen</span>)
</li></ol></pre></div></div>
<p>Functions are actually a special case of closures: blocks of code that can be called later. The code in a closure has access to things like variables and functions that were available in the scope where the closure was created, even if the closure is in a different scope when it is executed&mdash;you saw an example of this already with nested functions. You can write a closure without a name by surrounding code with braces (<code class="docutils literal"><span class="pre">{}</span></code>). Use <code class="docutils literal"><span class="pre">in</span></code> to separate the arguments and return type from the body.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="nv">numbers</span>.<span class="nv">map</span>({ (<span class="nv">number</span>: <span class="nc">Int</span>) -&gt; <span class="nc">Int</span> <span class="k">in</span>
</li><li>    <span class="k">let</span> <span class="nv">result</span> = <span class="m">3</span> * <span class="nv">number</span>
</li><li>    <span class="k">return</span> <span class="nv">result</span>
</li><li>})
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Rewrite the closure to return zero for all odd numbers.</p>
</div>
<p>You have several options for writing closures more concisely. When a closure&rsquo;s type is already known, such as the callback for a delegate, you can omit the type of its parameters, its return type, or both. Single statement closures implicitly return the value of their only statement.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">mappedNumbers</span> = <span class="nv">numbers</span>.<span class="nv">map</span>({ <span class="nv">number</span> <span class="k">in</span> <span class="m">3</span> * <span class="nv">number</span> })
</li><li><span class="nv">print</span>(<span class="nv">mappedNumbers</span>)
</li></ol></pre></div></div>
<p>You can refer to parameters by number instead of by name&mdash;this approach is especially useful in very short closures. A closure passed as the last argument to a function can appear immediately after the parentheses. When a closure is the only argument to a function, you can omit the parentheses entirely.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">sortedNumbers</span> = <span class="nv">numbers</span>.<span class="nv">sorted</span> { <span class="nv">$0</span> &gt; <span class="nv">$1</span> }
</li><li><span class="nv">print</span>(<span class="nv">sortedNumbers</span>)
</li></ol></pre></div></div>
</div>
<div class="section" id="ID464">
<a class="dashingAutolink" name="autolink-5"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Objects%20and%20Classes"></a><h2>Objects and Classes<a class="headerlink" href="GuidedTour.html#ID464" title="Permalink to this headline"></a></h2>
<p>Use <code class="docutils literal"><span class="pre">class</span></code> followed by the class&rsquo;s name to create a class. A property declaration in a class is written the same way as a constant or variable declaration, except that it is in the context of a class. Likewise, method and function declarations are written the same way.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">Shape</span> {
</li><li>    <span class="k">var</span> <span class="nv">numberOfSides</span> = <span class="m">0</span>
</li><li>    <span class="k">func</span> <span class="nv">simpleDescription</span>() -&gt; <span class="nc">String</span> {
</li><li>        <span class="k">return</span> <span class="s">&#34;A shape with </span>\<span class="p">(</span><span class="nv">numberOfSides</span><span class="p">)</span><span class="s"> sides.&#34;</span>
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Add a constant property with <code class="docutils literal"><span class="pre">let</span></code>, and add another method that takes an argument.</p>
</div>
<p>Create an instance of a class by putting parentheses after the class name. Use dot syntax to access the properties and methods of the instance.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">shape</span> = <span class="nv">Shape</span>()
</li><li><span class="nv">shape</span>.<span class="nv">numberOfSides</span> = <span class="m">7</span>
</li><li><span class="k">var</span> <span class="nv">shapeDescription</span> = <span class="nv">shape</span>.<span class="nv">simpleDescription</span>()
</li></ol></pre></div></div>
<p>This version of the <code class="docutils literal"><span class="pre">Shape</span></code> class is missing something important: an initializer to set up the class when an instance is created. Use <code class="docutils literal"><span class="pre">init</span></code> to create one.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">NamedShape</span> {
</li><li>    <span class="k">var</span> <span class="nv">numberOfSides</span>: <span class="nc">Int</span> = <span class="m">0</span>
</li><li>    <span class="k">var</span> <span class="nv">name</span>: <span class="nc">String</span>
</li><li>
</li><li>    <span class="k">init</span>(<span class="nv">name</span>: <span class="nc">String</span>) {
</li><li>        <span class="k">self</span>.<span class="nv">name</span> = <span class="nv">name</span>
</li><li>    }
</li><li>
</li><li>    <span class="k">func</span> <span class="nv">simpleDescription</span>() -&gt; <span class="nc">String</span> {
</li><li>        <span class="k">return</span> <span class="s">&#34;A shape with </span>\<span class="p">(</span><span class="nv">numberOfSides</span><span class="p">)</span><span class="s"> sides.&#34;</span>
</li><li>    }
</li><li>}
</li></ol></pre></div></div>
<p>Notice how <code class="docutils literal"><span class="pre">self</span></code> is used to distinguish the <code class="docutils literal"><span class="pre">name</span></code> property from the <code class="docutils literal"><span class="pre">name</span></code> argument to the initializer. The arguments to the initializer are passed like a function call when you create an instance of the class. Every property needs a value assigned&mdash;either in its declaration (as with <code class="docutils literal"><span class="pre">numberOfSides</span></code>) or in the initializer (as with <code class="docutils literal"><span class="pre">name</span></code>).</p>
<p>Use <code class="docutils literal"><span class="pre">deinit</span></code> to create a deinitializer if you need to perform some cleanup before the object is deallocated.</p>
<p>Subclasses include their superclass name after their class name, separated by a colon. There is no requirement for classes to subclass any standard root class, so you can include or omit a superclass as needed.</p>
<p>Methods on a subclass that override the superclass&rsquo;s implementation are marked with <code class="docutils literal"><span class="pre">override</span></code>&mdash;overriding a method by accident, without <code class="docutils literal"><span class="pre">override</span></code>, is detected by the compiler as an error. The compiler also detects methods with <code class="docutils literal"><span class="pre">override</span></code> that don&rsquo;t actually override any method in the superclass.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">Square</span>: <span class="nc">NamedShape</span> {
</li><li>    <span class="k">var</span> <span class="nv">sideLength</span>: <span class="nc">Double</span>
</li><li>
</li><li>    <span class="k">init</span>(<span class="nv">sideLength</span>: <span class="nc">Double</span>, <span class="nv">name</span>: <span class="nc">String</span>) {
</li><li>        <span class="k">self</span>.<span class="nv">sideLength</span> = <span class="nv">sideLength</span>
</li><li>        <span class="k">super</span>.<span class="nv">init</span>(<span class="nv">name</span>: <span class="nv">name</span>)
</li><li>        <span class="nv">numberOfSides</span> = <span class="m">4</span>
</li><li>    }
</li><li>
</li><li>    <span class="k">func</span> <span class="nv">area</span>() -&gt; <span class="nc">Double</span> {
</li><li>        <span class="k">return</span> <span class="nv">sideLength</span> * <span class="nv">sideLength</span>
</li><li>    }
</li><li>
</li><li>    <span class="k">override</span> <span class="k">func</span> <span class="nv">simpleDescription</span>() -&gt; <span class="nc">String</span> {
</li><li>        <span class="k">return</span> <span class="s">&#34;A square with sides of length </span>\<span class="p">(</span><span class="nv">sideLength</span><span class="p">)</span><span class="s">.&#34;</span>
</li><li>    }
</li><li>}
</li><li><span class="k">let</span> <span class="nv">test</span> = <span class="nv">Square</span>(<span class="nv">sideLength</span>: <span class="m">5.2</span>, <span class="nv">name</span>: <span class="s">&#34;my test square&#34;</span>)
</li><li><span class="nv">test</span>.<span class="nv">area</span>()
</li><li><span class="nv">test</span>.<span class="nv">simpleDescription</span>()
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Make another subclass of <code class="docutils literal"><span class="pre">NamedShape</span></code> called <code class="docutils literal"><span class="pre">Circle</span></code> that takes a radius and a name as arguments to its initializer. Implement an <code class="docutils literal"><span class="pre">area()</span></code> and a <code class="docutils literal"><span class="pre">simpleDescription()</span></code> method on the <code class="docutils literal"><span class="pre">Circle</span></code> class.</p>
</div>
<p>In addition to simple properties that are stored, properties can have a getter and a setter.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">EquilateralTriangle</span>: <span class="nc">NamedShape</span> {
</li><li>    <span class="k">var</span> <span class="nv">sideLength</span>: <span class="nc">Double</span> = <span class="m">0.0</span>
</li><li>
</li><li>    <span class="k">init</span>(<span class="nv">sideLength</span>: <span class="nc">Double</span>, <span class="nv">name</span>: <span class="nc">String</span>) {
</li><li>        <span class="k">self</span>.<span class="nv">sideLength</span> = <span class="nv">sideLength</span>
</li><li>        <span class="k">super</span>.<span class="nv">init</span>(<span class="nv">name</span>: <span class="nv">name</span>)
</li><li>        <span class="nv">numberOfSides</span> = <span class="m">3</span>
</li><li>    }
</li><li>
</li><li>    <span class="k">var</span> <span class="nv">perimeter</span>: <span class="nc">Double</span> {
</li><li>        <span class="k">get</span> {
</li><li>            <span class="k">return</span> <span class="m">3.0</span> * <span class="nv">sideLength</span>
</li><li>        }
</li><li>        <span class="k">set</span> {
</li><li>            <span class="nv">sideLength</span> = <span class="nv">newValue</span> / <span class="m">3.0</span>
</li><li>        }
</li><li>    }
</li><li>
</li><li>    <span class="k">override</span> <span class="k">func</span> <span class="nv">simpleDescription</span>() -&gt; <span class="nc">String</span> {
</li><li>        <span class="k">return</span> <span class="s">&#34;An equilateral triangle with sides of length </span>\<span class="p">(</span><span class="nv">sideLength</span><span class="p">)</span><span class="s">.&#34;</span>
</li><li>    }
</li><li>}
</li><li><span class="k">var</span> <span class="nv">triangle</span> = <span class="nv">EquilateralTriangle</span>(<span class="nv">sideLength</span>: <span class="m">3.1</span>, <span class="nv">name</span>: <span class="s">&#34;a triangle&#34;</span>)
</li><li><span class="nv">print</span>(<span class="nv">triangle</span>.<span class="nv">perimeter</span>)
</li><li><span class="nv">triangle</span>.<span class="nv">perimeter</span> = <span class="m">9.9</span>
</li><li><span class="nv">print</span>(<span class="nv">triangle</span>.<span class="nv">sideLength</span>)
</li></ol></pre></div></div>
<p>In the setter for <code class="docutils literal"><span class="pre">perimeter</span></code>, the new value has the implicit name <code class="docutils literal"><span class="pre">newValue</span></code>. You can provide an explicit name in parentheses after <code class="docutils literal"><span class="pre">set</span></code>.</p>
<p>Notice that the initializer for the <code class="docutils literal"><span class="pre">EquilateralTriangle</span></code> class has three different steps:</p>
<ol class="arabic simple">
<li>Setting the value of properties that the subclass declares.</li>
<li>Calling the superclass&rsquo;s initializer.</li>
<li>Changing the value of properties defined by the superclass. Any additional setup work that uses methods, getters, or setters can also be done at this point.</li>
</ol>
<p>If you don&rsquo;t need to compute the property but still need to provide code that is run before and after setting a new value, use <code class="docutils literal"><span class="pre">willSet</span></code> and <code class="docutils literal"><span class="pre">didSet</span></code>. The code you provide is run any time the value changes outside of an initializer. For example, the class below ensures that the side length of its triangle is always the same as the side length of its square.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">TriangleAndSquare</span> {
</li><li>    <span class="k">var</span> <span class="nv">triangle</span>: <span class="nc">EquilateralTriangle</span> {
</li><li>        <span class="k">willSet</span> {
</li><li>            <span class="nv">square</span>.<span class="nv">sideLength</span> = <span class="nv">newValue</span>.<span class="nv">sideLength</span>
</li><li>        }
</li><li>    }
</li><li>    <span class="k">var</span> <span class="nv">square</span>: <span class="nc">Square</span> {
</li><li>        <span class="k">willSet</span> {
</li><li>            <span class="nv">triangle</span>.<span class="nv">sideLength</span> = <span class="nv">newValue</span>.<span class="nv">sideLength</span>
</li><li>        }
</li><li>    }
</li><li>    <span class="k">init</span>(<span class="nv">size</span>: <span class="nc">Double</span>, <span class="nv">name</span>: <span class="nc">String</span>) {
</li><li>        <span class="nv">square</span> = <span class="nv">Square</span>(<span class="nv">sideLength</span>: <span class="nv">size</span>, <span class="nv">name</span>: <span class="nv">name</span>)
</li><li>        <span class="nv">triangle</span> = <span class="nv">EquilateralTriangle</span>(<span class="nv">sideLength</span>: <span class="nv">size</span>, <span class="nv">name</span>: <span class="nv">name</span>)
</li><li>    }
</li><li>}
</li><li><span class="k">var</span> <span class="nv">triangleAndSquare</span> = <span class="nv">TriangleAndSquare</span>(<span class="nv">size</span>: <span class="m">10</span>, <span class="nv">name</span>: <span class="s">&#34;another test shape&#34;</span>)
</li><li><span class="nv">print</span>(<span class="nv">triangleAndSquare</span>.<span class="nv">square</span>.<span class="nv">sideLength</span>)
</li><li><span class="nv">print</span>(<span class="nv">triangleAndSquare</span>.<span class="nv">triangle</span>.<span class="nv">sideLength</span>)
</li><li><span class="nv">triangleAndSquare</span>.<span class="nv">square</span> = <span class="nv">Square</span>(<span class="nv">sideLength</span>: <span class="m">50</span>, <span class="nv">name</span>: <span class="s">&#34;larger square&#34;</span>)
</li><li><span class="nv">print</span>(<span class="nv">triangleAndSquare</span>.<span class="nv">triangle</span>.<span class="nv">sideLength</span>)
</li></ol></pre></div></div>
<p>When working with optional values, you can write <code class="docutils literal"><span class="pre">?</span></code> before operations like methods, properties, and subscripting. If the value before the <code class="docutils literal"><span class="pre">?</span></code> is <code class="docutils literal"><span class="pre">nil</span></code>, everything after the <code class="docutils literal"><span class="pre">?</span></code> is ignored and the value of the whole expression is <code class="docutils literal"><span class="pre">nil</span></code>. Otherwise, the optional value is unwrapped, and everything after the <code class="docutils literal"><span class="pre">?</span></code> acts on the unwrapped value. In both cases, the value of the whole expression is an optional value.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">optionalSquare</span>: <span class="nc">Square</span>? = <span class="nv">Square</span>(<span class="nv">sideLength</span>: <span class="m">2.5</span>, <span class="nv">name</span>: <span class="s">&#34;optional square&#34;</span>)
</li><li><span class="k">let</span> <span class="nv">sideLength</span> = <span class="nv">optionalSquare</span>?.<span class="nv">sideLength</span>
</li></ol></pre></div></div>
</div>
<div class="section" id="ID465">
<a class="dashingAutolink" name="autolink-6"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Enumerations%20and%20Structures"></a><h2>Enumerations and Structures<a class="headerlink" href="GuidedTour.html#ID465" title="Permalink to this headline"></a></h2>
<p>Use <code class="docutils literal"><span class="pre">enum</span></code> to create an enumeration. Like classes and all other named types, enumerations can have methods associated with them.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">enum</span> <span class="nv">Rank</span>: <span class="nc">Int</span> {
</li><li>    <span class="k">case</span> <span class="nv">ace</span> = <span class="m">1</span>
</li><li>    <span class="k">case</span> <span class="nv">two</span>, <span class="nv">three</span>, <span class="nv">four</span>, <span class="nv">five</span>, <span class="nv">six</span>, <span class="nv">seven</span>, <span class="nv">eight</span>, <span class="nv">nine</span>, <span class="nv">ten</span>
</li><li>    <span class="k">case</span> <span class="nv">jack</span>, <span class="nv">queen</span>, <span class="nv">king</span>
</li><li>    <span class="k">func</span> <span class="nv">simpleDescription</span>() -&gt; <span class="nc">String</span> {
</li><li>        <span class="k">switch</span> <span class="k">self</span> {
</li><li>        <span class="k">case</span> .<span class="nv">ace</span>:
</li><li>            <span class="k">return</span> <span class="s">&#34;ace&#34;</span>
</li><li>        <span class="k">case</span> .<span class="nv">jack</span>:
</li><li>            <span class="k">return</span> <span class="s">&#34;jack&#34;</span>
</li><li>        <span class="k">case</span> .<span class="nv">queen</span>:
</li><li>            <span class="k">return</span> <span class="s">&#34;queen&#34;</span>
</li><li>        <span class="k">case</span> .<span class="nv">king</span>:
</li><li>            <span class="k">return</span> <span class="s">&#34;king&#34;</span>
</li><li>        <span class="k">default</span>:
</li><li>            <span class="k">return</span> <span class="nv">String</span>(<span class="k">self</span>.<span class="nv">rawValue</span>)
</li><li>        }
</li><li>    }
</li><li>}
</li><li><span class="k">let</span> <span class="nv">ace</span> = <span class="nv">Rank</span>.<span class="nv">ace</span>
</li><li><span class="k">let</span> <span class="nv">aceRawValue</span> = <span class="nv">ace</span>.<span class="nv">rawValue</span>
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Write a function that compares two <code class="docutils literal"><span class="pre">Rank</span></code> values by comparing their raw values.</p>
</div>
<p>By default, Swift assigns the raw values starting at zero and incrementing by one each time, but you can change this behavior by explicitly specifying values. In the example above, <code class="docutils literal"><span class="pre">Ace</span></code> is explicitly given a raw value of <code class="docutils literal"><span class="pre">1</span></code>, and the rest of the raw values are assigned in order. You can also use strings or floating-point numbers as the raw type of an enumeration. Use the <code class="docutils literal"><span class="pre">rawValue</span></code> property to access the raw value of an enumeration case.</p>
<p>Use the <code class="docutils literal"><span class="pre">init?(rawValue:)</span></code> initializer to make an instance of an enumeration from a raw value. It returns either the enumeration case matching the raw value or <code class="docutils literal"><span class="pre">nil</span></code> if there is no matching <code class="docutils literal"><span class="pre">Rank</span></code>.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">if</span> <span class="k">let</span> <span class="nv">convertedRank</span> = <span class="nv">Rank</span>(<span class="nv">rawValue</span>: <span class="m">3</span>) {
</li><li>    <span class="k">let</span> <span class="nv">threeDescription</span> = <span class="nv">convertedRank</span>.<span class="nv">simpleDescription</span>()
</li><li>}
</li></ol></pre></div></div>
<p>The case values of an enumeration are actual values, not just another way of writing their raw values. In fact, in cases where there isn&rsquo;t a meaningful raw value, you don&rsquo;t have to provide one.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">enum</span> <span class="nv">Suit</span> {
</li><li>    <span class="k">case</span> <span class="nv">spades</span>, <span class="nv">hearts</span>, <span class="nv">diamonds</span>, <span class="nv">clubs</span>
</li><li>    <span class="k">func</span> <span class="nv">simpleDescription</span>() -&gt; <span class="nc">String</span> {
</li><li>        <span class="k">switch</span> <span class="k">self</span> {
</li><li>        <span class="k">case</span> .<span class="nv">spades</span>:
</li><li>            <span class="k">return</span> <span class="s">&#34;spades&#34;</span>
</li><li>        <span class="k">case</span> .<span class="nv">hearts</span>:
</li><li>            <span class="k">return</span> <span class="s">&#34;hearts&#34;</span>
</li><li>        <span class="k">case</span> .<span class="nv">diamonds</span>:
</li><li>            <span class="k">return</span> <span class="s">&#34;diamonds&#34;</span>
</li><li>        <span class="k">case</span> .<span class="nv">clubs</span>:
</li><li>            <span class="k">return</span> <span class="s">&#34;clubs&#34;</span>
</li><li>        }
</li><li>    }
</li><li>}
</li><li><span class="k">let</span> <span class="nv">hearts</span> = <span class="nv">Suit</span>.<span class="nv">hearts</span>
</li><li><span class="k">let</span> <span class="nv">heartsDescription</span> = <span class="nv">hearts</span>.<span class="nv">simpleDescription</span>()
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Add a <code class="docutils literal"><span class="pre">color()</span></code> method to <code class="docutils literal"><span class="pre">Suit</span></code> that returns &ldquo;black&rdquo; for spades and clubs, and returns &ldquo;red&rdquo; for hearts and diamonds.</p>
</div>
<p>Notice the two ways that the <code class="docutils literal"><span class="pre">hearts</span></code> case of the enumeration is referred to above: When assigning a value to the <code class="docutils literal"><span class="pre">hearts</span></code> constant, the enumeration case <code class="docutils literal"><span class="pre">Suit.hearts</span></code> is referred to by its full name because the constant doesn&rsquo;t have an explicit type specified. Inside the switch, the enumeration case is referred to by the abbreviated form <code class="docutils literal"><span class="pre">.hearts</span></code> because the value of <code class="docutils literal"><span class="pre">self</span></code> is already known to be a suit. You can use the abbreviated form anytime the value&rsquo;s type is already known.</p>
<p>If an enumeration has raw values, those values are determined as part of the declaration, which means every instance of a particular enumeration case always has the same raw value. Another choice for enumeration cases is to have values associated with the case&mdash;these values are determined when you make the instance, and they can be different for each instance of an enumeration case. You can think of the associated values as behaving like stored properties of the enumeration case instance. For example, consider the case of requesting the sunrise and sunset times from a server. The server either responds with the requested information, or it responds with a description of what went wrong.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">enum</span> <span class="nv">ServerResponse</span> {
</li><li>    <span class="k">case</span> <span class="nv">result</span>(<span class="nv">String</span>, <span class="nv">String</span>)
</li><li>    <span class="k">case</span> <span class="nv">failure</span>(<span class="nv">String</span>)
</li><li>}
</li><li>
</li><li><span class="k">let</span> <span class="nv">success</span> = <span class="nv">ServerResponse</span>.<span class="nv">result</span>(<span class="s">&#34;6:00 am&#34;</span>, <span class="s">&#34;8:09 pm&#34;</span>)
</li><li><span class="k">let</span> <span class="nv">failure</span> = <span class="nv">ServerResponse</span>.<span class="nv">failure</span>(<span class="s">&#34;Out of cheese.&#34;</span>)
</li><li>
</li><li><span class="k">switch</span> <span class="nv">success</span> {
</li><li><span class="k">case</span> <span class="k">let</span> .<span class="nv">result</span>(<span class="nv">sunrise</span>, <span class="nv">sunset</span>):
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Sunrise is at </span>\<span class="p">(</span><span class="nv">sunrise</span><span class="p">)</span><span class="s"> and sunset is at </span>\<span class="p">(</span><span class="nv">sunset</span><span class="p">)</span><span class="s">.&#34;</span>)
</li><li><span class="k">case</span> <span class="k">let</span> .<span class="nv">failure</span>(<span class="nv">message</span>):
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Failure...  </span>\<span class="p">(</span><span class="nv">message</span><span class="p">)</span><span class="s">&#34;</span>)
</li><li>}
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Add a third case to <code class="docutils literal"><span class="pre">ServerResponse</span></code> and to the switch.</p>
</div>
<p>Notice how the sunrise and sunset times are extracted from the <code class="docutils literal"><span class="pre">ServerResponse</span></code> value as part of matching the value against the switch cases.</p>
<p>Use <code class="docutils literal"><span class="pre">struct</span></code> to create a structure. Structures support many of the same behaviors as classes, including methods and initializers. One of the most important differences between structures and classes is that structures are always copied when they are passed around in your code, but classes are passed by reference.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">struct</span> <span class="nv">Card</span> {
</li><li>    <span class="k">var</span> <span class="nv">rank</span>: <span class="nc">Rank</span>
</li><li>    <span class="k">var</span> <span class="nv">suit</span>: <span class="nc">Suit</span>
</li><li>    <span class="k">func</span> <span class="nv">simpleDescription</span>() -&gt; <span class="nc">String</span> {
</li><li>        <span class="k">return</span> <span class="s">&#34;The </span>\<span class="p">(</span><span class="nv">rank</span>.<span class="nv">simpleDescription</span>()<span class="p">)</span><span class="s"> of </span>\<span class="p">(</span><span class="nv">suit</span>.<span class="nv">simpleDescription</span>()<span class="p">)</span><span class="s">&#34;</span>
</li><li>    }
</li><li>}
</li><li><span class="k">let</span> <span class="nv">threeOfSpades</span> = <span class="nv">Card</span>(<span class="nv">rank</span>: .<span class="nv">three</span>, <span class="nv">suit</span>: .<span class="nv">spades</span>)
</li><li><span class="k">let</span> <span class="nv">threeOfSpadesDescription</span> = <span class="nv">threeOfSpades</span>.<span class="nv">simpleDescription</span>()
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Add a method to <code class="docutils literal"><span class="pre">Card</span></code> that creates a full deck of cards, with one card of each combination of rank and suit.</p>
</div>
</div>
<div class="section" id="ID466">
<a class="dashingAutolink" name="autolink-7"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Protocols%20and%20Extensions"></a><h2>Protocols and Extensions<a class="headerlink" href="GuidedTour.html#ID466" title="Permalink to this headline"></a></h2>
<p>Use <code class="docutils literal"><span class="pre">protocol</span></code> to declare a protocol.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">protocol</span> <span class="nv">ExampleProtocol</span> {
</li><li>    <span class="k">var</span> <span class="nv">simpleDescription</span>: <span class="nc">String</span> { <span class="k">get</span> }
</li><li>    <span class="k">mutating</span> <span class="k">func</span> <span class="nv">adjust</span>()
</li><li>}
</li></ol></pre></div></div>
<p>Classes, enumerations, and structs can all adopt protocols.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">class</span> <span class="nv">SimpleClass</span>: <span class="nc">ExampleProtocol</span> {
</li><li>    <span class="k">var</span> <span class="nv">simpleDescription</span>: <span class="nc">String</span> = <span class="s">&#34;A very simple class.&#34;</span>
</li><li>    <span class="k">var</span> <span class="nv">anotherProperty</span>: <span class="nc">Int</span> = <span class="m">69105</span>
</li><li>    <span class="k">func</span> <span class="nv">adjust</span>() {
</li><li>        <span class="nv">simpleDescription</span> += <span class="s">&#34;  Now 100% adjusted.&#34;</span>
</li><li>    }
</li><li>}
</li><li><span class="k">var</span> <span class="nv">a</span> = <span class="nv">SimpleClass</span>()
</li><li><span class="nv">a</span>.<span class="nv">adjust</span>()
</li><li><span class="k">let</span> <span class="nv">aDescription</span> = <span class="nv">a</span>.<span class="nv">simpleDescription</span>
</li><li>
</li><li><span class="k">struct</span> <span class="nv">SimpleStructure</span>: <span class="nc">ExampleProtocol</span> {
</li><li>    <span class="k">var</span> <span class="nv">simpleDescription</span>: <span class="nc">String</span> = <span class="s">&#34;A simple structure&#34;</span>
</li><li>    <span class="k">mutating</span> <span class="k">func</span> <span class="nv">adjust</span>() {
</li><li>        <span class="nv">simpleDescription</span> += <span class="s">&#34; (adjusted)&#34;</span>
</li><li>    }
</li><li>}
</li><li><span class="k">var</span> <span class="nv">b</span> = <span class="nv">SimpleStructure</span>()
</li><li><span class="nv">b</span>.<span class="nv">adjust</span>()
</li><li><span class="k">let</span> <span class="nv">bDescription</span> = <span class="nv">b</span>.<span class="nv">simpleDescription</span>
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Write an enumeration that conforms to this protocol.</p>
</div>
<p>Notice the use of the <code class="docutils literal"><span class="pre">mutating</span></code> keyword in the declaration of <code class="docutils literal"><span class="pre">SimpleStructure</span></code> to mark a method that modifies the structure. The declaration of <code class="docutils literal"><span class="pre">SimpleClass</span></code> doesn&rsquo;t need any of its methods marked as mutating because methods on a class can always modify the class.</p>
<p>Use <code class="docutils literal"><span class="pre">extension</span></code> to add functionality to an existing type, such as new methods and computed properties. You can use an extension to add protocol conformance to a type that is declared elsewhere, or even to a type that you imported from a library or framework.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">extension</span> <span class="nc">Int</span>: <span class="nc">ExampleProtocol</span> {
</li><li>    <span class="k">var</span> <span class="nv">simpleDescription</span>: <span class="nc">String</span> {
</li><li>        <span class="k">return</span> <span class="s">&#34;The number </span>\<span class="p">(</span><span class="k">self</span><span class="p">)</span><span class="s">&#34;</span>
</li><li>    }
</li><li>    <span class="k">mutating</span> <span class="k">func</span> <span class="nv">adjust</span>() {
</li><li>        <span class="k">self</span> += <span class="m">42</span>
</li><li>    }
</li><li>}
</li><li><span class="nv">print</span>(<span class="m">7</span>.<span class="nv">simpleDescription</span>)
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Write an extension for the <code class="docutils literal"><span class="pre">Double</span></code> type that adds an <code class="docutils literal"><span class="pre">absoluteValue</span></code> property.</p>
</div>
<p>You can use a protocol name just like any other named type&mdash;for example, to create a collection of objects that have different types but that all conform to a single protocol. When you work with values whose type is a protocol type, methods outside the protocol definition are not available.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">protocolValue</span>: <span class="nc">ExampleProtocol</span> = <span class="nv">a</span>
</li><li><span class="nv">print</span>(<span class="nv">protocolValue</span>.<span class="nv">simpleDescription</span>)
</li><li><span class="c">// print(protocolValue.anotherProperty)  // Uncomment to see the error</span>
</li></ol></pre></div></div>
<p>Even though the variable <code class="docutils literal"><span class="pre">protocolValue</span></code> has a runtime type of <code class="docutils literal"><span class="pre">SimpleClass</span></code>, the compiler treats it as the given type of <code class="docutils literal"><span class="pre">ExampleProtocol</span></code>. This means that you can&rsquo;t accidentally access methods or properties that the class implements in addition to its protocol conformance.</p>
</div>
<div class="section" id="error-handling">
<a class="dashingAutolink" name="autolink-8"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Error%20Handling"></a><h2>Error Handling<a class="headerlink" href="GuidedTour.html#error-handling" title="Permalink to this headline"></a></h2>
<p>You represent errors using any type that adopts the <code class="docutils literal"><span class="pre">Error</span></code> protocol.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">enum</span> <span class="nv">PrinterError</span>: <span class="nc">Error</span> {
</li><li>    <span class="k">case</span> <span class="nv">outOfPaper</span>
</li><li>    <span class="k">case</span> <span class="nv">noToner</span>
</li><li>    <span class="k">case</span> <span class="nv">onFire</span>
</li><li>}
</li></ol></pre></div></div>
<p>Use <code class="docutils literal"><span class="pre">throw</span></code> to throw an error and <code class="docutils literal"><span class="pre">throws</span></code> to mark a function that can throw an error. If you throw an error in a function, the function returns immediately and the code that called the function handles the error.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">send</span>(<span class="nv">job</span>: <span class="nc">Int</span>, <span class="nv">toPrinter</span> <span class="nv">printerName</span>: <span class="nc">String</span>) <span class="k">throws</span> -&gt; <span class="nc">String</span> {
</li><li>    <span class="k">if</span> <span class="nv">printerName</span> == <span class="s">&#34;Never Has Toner&#34;</span> {
</li><li>        <span class="k">throw</span> <span class="nv">PrinterError</span>.<span class="nv">noToner</span>
</li><li>    }
</li><li>    <span class="k">return</span> <span class="s">&#34;Job sent&#34;</span>
</li><li>}
</li></ol></pre></div></div>
<p>There are several ways to handle errors. One way is to use <code class="docutils literal"><span class="pre">do</span></code>-<code class="docutils literal"><span class="pre">catch</span></code>. Inside the <code class="docutils literal"><span class="pre">do</span></code> block, you mark code that can throw an error by writing <code class="docutils literal"><span class="pre">try</span></code> in front of it. Inside the <code class="docutils literal"><span class="pre">catch</span></code> block, the error is automatically given the name <code class="docutils literal"><span class="pre">error</span></code> unless you give it a different name.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">do</span> {
</li><li>    <span class="k">let</span> <span class="nv">printerResponse</span> = <span class="k">try</span> <span class="nv">send</span>(<span class="nv">job</span>: <span class="m">1040</span>, <span class="nv">toPrinter</span>: <span class="s">&#34;Bi Sheng&#34;</span>)
</li><li>    <span class="nv">print</span>(<span class="nv">printerResponse</span>)
</li><li>} <span class="k">catch</span> {
</li><li>    <span class="nv">print</span>(<span class="nv">error</span>)
</li><li>}
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Change the printer name to <code class="docutils literal"><span class="pre">&#34;Never</span> <span class="pre">Has</span> <span class="pre">Toner&#34;</span></code>, so that the <code class="docutils literal"><span class="pre">send(job:toPrinter:)</span></code> function throws an error.</p>
</div>
<p>You can provide multiple <code class="docutils literal"><span class="pre">catch</span></code> blocks that handle specific errors. You write a pattern after <code class="docutils literal"><span class="pre">catch</span></code> just as you do after <code class="docutils literal"><span class="pre">case</span></code> in a switch.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">do</span> {
</li><li>    <span class="k">let</span> <span class="nv">printerResponse</span> = <span class="k">try</span> <span class="nv">send</span>(<span class="nv">job</span>: <span class="m">1440</span>, <span class="nv">toPrinter</span>: <span class="s">&#34;Gutenberg&#34;</span>)
</li><li>    <span class="nv">print</span>(<span class="nv">printerResponse</span>)
</li><li>} <span class="k">catch</span> <span class="nv">PrinterError</span>.<span class="nv">onFire</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;I&#39;ll just put this over here, with the rest of the fire.&#34;</span>)
</li><li>} <span class="k">catch</span> <span class="k">let</span> <span class="nv">printerError</span> <span class="k">as</span> <span class="nc">PrinterError</span> {
</li><li>    <span class="nv">print</span>(<span class="s">&#34;Printer error: </span>\<span class="p">(</span><span class="nv">printerError</span><span class="p">)</span><span class="s">.&#34;</span>)
</li><li>} <span class="k">catch</span> {
</li><li>    <span class="nv">print</span>(<span class="nv">error</span>)
</li><li>}
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Add code to throw an error inside the <code class="docutils literal"><span class="pre">do</span></code> block. What kind of error do you need to throw so that the error is handled by the first <code class="docutils literal"><span class="pre">catch</span></code> block? What about the second and third blocks?</p>
</div>
<p>Another way to handle errors is to use <code class="docutils literal"><span class="pre">try?</span></code> to convert the result to an optional. If the function throws an error, the specific error is discarded and the result is <code class="docutils literal"><span class="pre">nil</span></code>. Otherwise, the result is an optional containing the value that the function returned.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">let</span> <span class="nv">printerSuccess</span> = <span class="k">try</span>? <span class="nv">send</span>(<span class="nv">job</span>: <span class="m">1884</span>, <span class="nv">toPrinter</span>: <span class="s">&#34;Mergenthaler&#34;</span>)
</li><li><span class="k">let</span> <span class="nv">printerFailure</span> = <span class="k">try</span>? <span class="nv">send</span>(<span class="nv">job</span>: <span class="m">1885</span>, <span class="nv">toPrinter</span>: <span class="s">&#34;Never Has Toner&#34;</span>)
</li></ol></pre></div></div>
<p>Use <code class="docutils literal"><span class="pre">defer</span></code> to write a block of code that is executed after all other code in the function, just before the function returns. The code is executed regardless of whether the function throws an error. You can use <code class="docutils literal"><span class="pre">defer</span></code> to write setup and cleanup code next to each other, even though they need to be executed at different times.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">var</span> <span class="nv">fridgeIsOpen</span> = <span class="k">false</span>
</li><li><span class="k">let</span> <span class="nv">fridgeContent</span> = [<span class="s">&#34;milk&#34;</span>, <span class="s">&#34;eggs&#34;</span>, <span class="s">&#34;leftovers&#34;</span>]
</li><li>
</li><li><span class="k">func</span> <span class="nv">fridgeContains</span>(<span class="k">_</span> <span class="nv">food</span>: <span class="nc">String</span>) -&gt; <span class="nc">Bool</span> {
</li><li>    <span class="nv">fridgeIsOpen</span> = <span class="k">true</span>
</li><li>    <span class="k">defer</span> {
</li><li>        <span class="nv">fridgeIsOpen</span> = <span class="k">false</span>
</li><li>    }
</li><li>
</li><li>    <span class="k">let</span> <span class="nv">result</span> = <span class="nv">fridgeContent</span>.<span class="nv">contains</span>(<span class="nv">food</span>)
</li><li>    <span class="k">return</span> <span class="nv">result</span>
</li><li>}
</li><li><span class="nv">fridgeContains</span>(<span class="s">&#34;banana&#34;</span>)
</li><li><span class="nv">print</span>(<span class="nv">fridgeIsOpen</span>)
</li></ol></pre></div></div>
</div>
<div class="section" id="generics">
<a class="dashingAutolink" name="autolink-9"></a><a class="dashAnchor" name="//apple_ref/cpp/Section/Generics"></a><h2>Generics<a class="headerlink" href="GuidedTour.html#generics" title="Permalink to this headline"></a></h2>
<p>Write a name inside angle brackets to make a generic function or type.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">makeArray</span>&lt;<span class="nv">Item</span>&gt;(<span class="nv">repeating</span> <span class="nv">item</span>: <span class="nc">Item</span>, <span class="nv">numberOfTimes</span>: <span class="nc">Int</span>) -&gt; [<span class="nc">Item</span>] {
</li><li>    <span class="k">var</span> <span class="nv">result</span> = [<span class="nc">Item</span>]()
</li><li>    <span class="k">for</span> <span class="k">_</span> <span class="k">in</span> <span class="m">0</span>..&lt;<span class="nv">numberOfTimes</span> {
</li><li>        <span class="nv">result</span>.<span class="nv">append</span>(<span class="nv">item</span>)
</li><li>    }
</li><li>    <span class="k">return</span> <span class="nv">result</span>
</li><li>}
</li><li><span class="nv">makeArray</span>(<span class="nv">repeating</span>: <span class="s">&#34;knock&#34;</span>, <span class="nv">numberOfTimes</span>: <span class="m">4</span>)
</li></ol></pre></div></div>
<p>You can make generic forms of functions and methods, as well as classes, enumerations, and structures.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="c">// Reimplement the Swift standard library&#39;s optional type</span>
</li><li><span class="k">enum</span> <span class="nv">OptionalValue</span>&lt;<span class="nv">Wrapped</span>&gt; {
</li><li>    <span class="k">case</span> <span class="nv">none</span>
</li><li>    <span class="k">case</span> <span class="nv">some</span>(<span class="nv">Wrapped</span>)
</li><li>}
</li><li><span class="k">var</span> <span class="nv">possibleInteger</span>: <span class="nc">OptionalValue</span>&lt;<span class="nc">Int</span>&gt; = .<span class="nv">none</span>
</li><li><span class="nv">possibleInteger</span> = .<span class="nv">some</span>(<span class="m">100</span>)
</li></ol></pre></div></div>
<p>Use <code class="docutils literal"><span class="pre">where</span></code> right before the body to specify a list of requirements&mdash;for example, to require the type to implement a protocol, to require two types to be the same, or to require a class to have a particular superclass.</p>
<div class="highlight-swift"><div class="code-sample"><pre class="Swift highlight"><ol class="code-lines"><li><span class="k">func</span> <span class="nv">anyCommonElements</span>&lt;<span class="nv">T</span>: <span class="nc">Sequence</span>, <span class="nv">U</span>: <span class="nc">Sequence</span>&gt;(<span class="k">_</span> <span class="nv">lhs</span>: <span class="nc">T</span>, <span class="k">_</span> <span class="nv">rhs</span>: <span class="nc">U</span>) -&gt; <span class="nc">Bool</span>
</li><li>    <span class="k">where</span> <span class="nc">T</span>.<span class="nc">Iterator</span>.<span class="nc">Element</span>: <span class="nc">Equatable</span>, <span class="nc">T</span>.<span class="nc">Iterator</span>.<span class="nc">Element</span> == <span class="nc">U</span>.<span class="nc">Iterator</span>.<span class="nc">Element</span> {
</li><li>        <span class="k">for</span> <span class="nv">lhsItem</span> <span class="k">in</span> <span class="nv">lhs</span> {
</li><li>            <span class="k">for</span> <span class="nv">rhsItem</span> <span class="k">in</span> <span class="nv">rhs</span> {
</li><li>                <span class="k">if</span> <span class="nv">lhsItem</span> == <span class="nv">rhsItem</span> {
</li><li>                    <span class="k">return</span> <span class="k">true</span>
</li><li>                }
</li><li>            }
</li><li>        }
</li><li>        <span class="k">return</span> <span class="k">false</span>
</li><li>}
</li><li><span class="nv">anyCommonElements</span>([<span class="m">1</span>, <span class="m">2</span>, <span class="m">3</span>], [<span class="m">3</span>])
</li></ol></pre></div></div>
<div class="admonition-experiment admonition">
<p class="first admonition-title">Experiment</p>
<p class="last">Modify the <code class="docutils literal"><span class="pre">anyCommonElements(_:_:)</span></code> function to make a function that returns an array of the elements that any two sequences have in common.</p>
</div>
<p>Writing <code class="docutils literal"><span class="pre">&lt;T:</span> <span class="pre">Equatable&gt;</span></code> is the same as writing <code class="docutils literal"><span class="pre">&lt;T&gt;</span> <span class="pre">...</span> <span class="pre">where</span> <span class="pre">T:</span> <span class="pre">Equatable</span></code>.</p>
</div>
</div>


    </article>
    <div class="next_previous">
        <p class="previous"><a href="Compatibility.html">Version Compatibility</a></p>
        <p class="next"><a href="../LanguageGuide/TheBasics.html">The Basics</a></p>
    </div>

    <div class="admonition-beta admonition">
        <p class="first admonition-title">Beta Software</p>
        <p>
          This documentation contains preliminary information about an API or technology in development.
          This information is subject to change, and software implemented according to this documentation should be tested with final operating system software.
        </p>
        <p class="last"><a class="reference external" href="https://developer.apple.com/support/beta-software/">Learn more about using Apple&#39;s beta software</a></p>
    </div>
</main>


<footer role="contentinfo">
  <aside>
    <a href="https://swift.org/atom.xml" title="Subscribe to Site Updates"><i class="feed">Subscribe</i></a>
    <a href="https://twitter.com/swiftlang" rel="nofollow" title="Follow @SwiftLang on Twitter"><i class="twitter">Twitter</i></a>
  </aside>

  <p class="copyright">Copyright &copy; 2018 Apple Inc. All rights reserved.</p>
  <p class="trademark">Swift and the Swift logo are trademarks of Apple Inc.</p>
  <p class="privacy">
    <a href="https://www.apple.com/privacy/privacy-policy/">Privacy Policy</a>
    <a href="https://www.apple.com/legal/privacy/en-ww/cookies/">Cookies</a>
  </p>
</footer>
<div id="jump_to_overlay"></div>
<script src="../_static/javascripts/application.js"></script>
  

</body></html>